=== debian/changelog ===
rustc (1.49.0+dfsg1-1+rpi1) bookworm-staging; urgency=medium

  [changes brought forward from 1.15.1+dfsg1-1~exp3+rpi1 by Peter Michael Green <plugwash@raspbian.org> at Wed, 15 Mar 2017 10:16:18 +0000]
  * Build for armv6.
  [changes introduced in 1.18.0+dfsg1-4+rpi1 by Peter Michael Green]
  * Disable testsuite.
  [changes introduced in 1.37.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Set DEB_BUILD_RUST_TYPE based on the compiler that is actually installed.
  [changes introduced in 1.42.0+dfsg1-1+rpi1 by Peter Michael Green]
  * Use the compiler itself rather than dpkg to detect DEB_BUILD_RUST_TYPE

 -- Raspbian forward porter <root@raspbian.org>  Thu, 09 Sep 2021 17:29:46 +0000

rustc (1.49.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Sat, 28 Aug 2021 10:48:11 +0100

rustc (1.49.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Mon, 05 Apr 2021 14:59:34 +0100

rustc (1.49.0~beta.4+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 20 Dec 2020 23:26:55 +0000
