## rustc 1.50.0+dfsg1+llvm

=== debian/changelog ===
rustc (1.50.0+dfsg1+llvm-0ubuntu5) hirsute; urgency=medium

  * No change rebuild rebootstrap.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 01 Apr 2021 21:54:48 +0100

rustc (1.50.0+dfsg1+llvm-0ubuntu4) hirsute; urgency=medium

  * Drop d/patches/0001-Revert-Auto-merge-of-79547.patch.
  * Cherrypick llvm toolchain fix for s390x from 1.51 beta.
  * Build against older 1.49 rustc.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 25 Mar 2021 13:30:52 +0000

rustc (1.50.0+dfsg1+llvm-0ubuntu3) hirsute; urgency=medium

  * Rebuild against the previous upload.
  * Restore the upper cap on the rustc build-dependency.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 24 Mar 2021 22:27:48 +0000

rustc (1.50.0+dfsg1+llvm-0ubuntu2) hirsute; urgency=medium

  [ Michael Hudson-Doyle ]
  * d/patches/0001-Revert-Auto-merge-of-79547.patch: Revert a patch that
    causes LLVM to generate bad code on s390x.  See
    https://github.com/rust-lang/rust/issues/80810.

  [ Dimitri John Ledkov ]
  * Built against older 1.49 rustc.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 23 Mar 2021 18:45:53 +0000

rustc (1.50.0+dfsg1+llvm-0ubuntu1) hirsute; urgency=medium

  * New upstream release. (LP: #1915722)
  * Update patches.
  * Update d/copyright.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 04 Mar 2021 10:17:58 +1300

rustc (1.49.0+dfsg1+llvm-0ubuntu1) hirsute; urgency=medium

  * Merge 1.49.0~beta.4+dfsg1-1~exp1 from Debian experimental (LP #1915722).
    Remaining changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
      - update debian/control
    - Adjust debian/watch to include +llvm in upstream version.
      - update debian/watch
    - Add Build-Depends-Indep: libssl-dev
    - Revert workaround for upstream bug #74786
    - Disable wasm build as build dependencies not currently available in
      Ubuntu.
    - Do not build windows cross compiler.
    - Try reducing parallelism in rustbuild on arm64 to avoid OOM.
  * Update to 1.49.0 final release.
  * Drop d-fix-mips64el-bootstrap.patch.
  * Reduce parallelism during build on s390x too.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Mon, 01 Mar 2021 21:39:26 +1300

rustc (1.49.0~beta.4+dfsg1-1~exp1) UNRELEASED; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sun, 20 Dec 2020 15:08:14 +0000

rustc (1.48.0+dfsg1+llvm-2ubuntu1) hirsute; urgency=medium

  * Merge 1.48.0+dfsg1-2 from Debian unstable (LP #1915722). Remaining
    changes:
    - Use the bundled llvm to avoid having to do llvm updates in order to
      deliver rust updates
      - update debian/config.toml.in
      - update debian/control
      - update debian/copyright
      - update debian/rules
    - Build-Depend on libc6-dbg on armhf, to workaround a crash in ld.so
      during some debuginfo tests
      - update debian/control
    - Add a hack to ensure the stage0 compiler is extracted to the correct
      location
      - update debian/make_orig-stage0_tarball.sh
    - Scrub -g from CFLAGS and CXXFLAGS in order to let rustbuild control
      whether LLVM is compiled with debug symbols
      - update debian/rules
    - On i386, only build debuginfo for libstd
      - update debian/rules
    - Ignore all test failures on every architecture
      - update debian/rules
    - Version the Build-Conflict on gdb-minimal as gdb now Provides it
      - update debian/control
    - Adjust the rustc Breaks/Replaces libstd-rust-dev version to fix an
      upgrade issue
      - update debian/control
    - Adjust debian/watch to include +llvm in upstream version.
      - update debian/watch
    - Add Build-Depends-Indep: libssl-dev
    - Revert workaround for upstream bug #74786
    - Disable wasm build as build dependencies not currently available in
      Ubuntu.
    - Do not build windows cross compiler.
    - Try reducing parallelism in rustbuild on arm64 to avoid OOM.

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 26 Feb 2021 08:13:28 +1300

rustc (1.47.0+dfsg1+llvm-1ubuntu2) hirsute; urgency=medium

  * No change rebuild against new glibc-32 ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 15 Feb 2021 22:37:11 +0000
