=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: rustc
 Section: devel
 Priority: optional
-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
 Uploaders:
  Ximin Luo <infinity0@debian.org>,
  Sylvestre Ledru <sylvestre@debian.org>
@@ -13,13 +14,8 @@
  dpkg-dev (>= 1.17.14),
  python3:native,
  cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
- rustc:native (>= 1.48.0+dfsg) <!pkg.rustc.dlstage0>,
- rustc:native (<= 1.49.0++)    <!pkg.rustc.dlstage0>,
- llvm-11-dev:native,
- llvm-11-tools:native,
- gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
-# FIXME #540782 gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
- libllvm11,
+ rustc:native (>= 1.49.0~~)    <!pkg.rustc.dlstage0>,
+ rustc:native (<= 1.50.0++)    <!pkg.rustc.dlstage0>,
  cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
  pkg-config,
@@ -28,20 +24,23 @@
  zlib1g-dev,
 # used by rust-installer
  liblzma-dev:native,
+# Required for llvm build
+ autotools-dev,
+ m4,
+ ninja-build,
 # test dependencies:
  binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
  git <!nocheck>,
  procps <!nocheck>,
 # below are optional tools even for 'make check'
  gdb (>= 7.12) <!nocheck>,
+ libc6-dbg [armhf],
 # Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
- wasi-libc (>= 0.0~git20200731.215adc8~~) <!nowasm>,
- wasi-libc (<= 0.0~git20200731.215adc8++) <!nowasm>,
- clang-11:native,
-Build-Conflicts: gdb-minimal <!nocheck>
+ libssl-dev,
+Build-Conflicts: gdb-minimal (<< 8.1-0ubuntu6) <!nocheck>
 Standards-Version: 4.2.1
 Homepage: http://www.rust-lang.org/
 Vcs-Git: https://salsa.debian.org/rust-team/rust.git
@@ -55,8 +54,8 @@
  gcc, libc-dev, binutils (>= 2.26)
 Recommends: cargo (>= 0.50.0~~), cargo (<< 0.51.0~~), rust-gdb | rust-lldb
 Suggests: rust-doc, rust-src, lld-11
-Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
-Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
+Replaces: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
+Breaks: libstd-rust-dev (<< 1.26.2+dfsg1+llvm-0ubuntu1~~)
 Description: Rust systems programming language
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -70,7 +69,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.49
+Package: libstd-rust-1.50
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -96,7 +95,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.49 (= ${binary:Version})
+Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-1.50 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -113,60 +112,6 @@
  This package contains development files for the standard Rust libraries,
  needed to compile Rust programs. It may also be installed on a system
  of another host architecture, for cross-compiling to this architecture.
-
-Package: libstd-rust-dev-windows
-Section: libdevel
-# FIXME #540782 Architecture: amd64 i386
-Architecture: amd64
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends:
- gcc-mingw-w64-x86-64-posix [amd64],
-# FIXME #540782 gcc-mingw-w64-i686-posix [i386],
-Build-Profiles: <!nowindows>
-Description: Rust standard libraries - development files
- Rust is a curly-brace, block-structured expression language.  It
- visually resembles the C language family, but differs significantly
- in syntactic and semantic details.  Its design is oriented toward
- concerns of "programming in the large", that is, of creating and
- maintaining boundaries - both abstract and operational - that
- preserve large-system integrity, availability and concurrency.
- .
- It supports a mixture of imperative procedural, concurrent actor,
- object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package contains the standard Rust libraries including development files,
- needed to cross-compile Rust programs to the *-pc-windows-gnu target
- corresponding to the architecture of this package.
-
-Package: libstd-rust-dev-wasm32
-Section: libdevel
-Architecture: all
-Multi-Arch: foreign
-Depends: ${shlibs:Depends}, ${misc:Depends}
-# Embeds wasi-libc so doesn't need to depend on it
-# None of its licenses require source redistrib, so no need for Built-Using
-Recommends: lld-11
-Suggests: clang-11
-Build-Profiles: <!nowasm>
-Description: Rust standard libraries - development files
- Rust is a curly-brace, block-structured expression language.  It
- visually resembles the C language family, but differs significantly
- in syntactic and semantic details.  Its design is oriented toward
- concerns of "programming in the large", that is, of creating and
- maintaining boundaries - both abstract and operational - that
- preserve large-system integrity, availability and concurrency.
- .
- It supports a mixture of imperative procedural, concurrent actor,
- object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package contains the standard Rust libraries including development files,
- needed to cross-compile Rust programs to the wasm32-unknown-unknown and
- wasm32-wasi targets.
 
 Package: rust-gdb
 Architecture: all
